#include <stdio.h>
#include <motelib/system.h>
#include <motelib/radio.h>
#include <motelib/uart.h>
#include <motelib/timer.h>

char data[5];
uint32_t wait_time;
Timer t;

void readRx(uint8_t m);
void sentTx();
void runComplete(Address src, MessageType type, void *msg, uint8_t len);

void boot() {
  //timerCreate(&t);
  //timerStart(&t, TIMER_PERIODIC, 500, readRx);
  uartEnable(true, true);
  uartWatchInputBytes(4, readRx);
  radioSetRxHandler(runComplete);
}

void readRx(uint8_t m) {
  uartRead(&data, 4);
  data[4] = '\0';
  printf("send: %s\n\r", data);
  radioRequestTx(0, 22, &data, sizeof(data)-1, sentTx);
}

void runComplete(Address src, MessageType type, void *msg, uint8_t len) {
  //wait_time = (((uint8_t*) msg)[0] << 24) + (((uint8_t*) msg)[1] << 16) + (((uint8_t*) msg)[2] << 8) + (((uint8_t*) msg)[3]);
  //printf("wait time = %d\n\r", wait_time);
  printf("run complete\n\r");
}

void sentTx() {
  printf("sent message complete\n\r");
  uartWatchInputBytes(4, readRx);
}
